#!/bin/sh

# cdoc -- Shell script documentation generator, similar to javadoc, for C

FILES="$@"
mkdir -p cdoc
idx="cdoc/index.html"
echo -e "<html><head><title>cDOC index</title></head>\n<body>" >$idx
echo "<h4>Available documentation</h4>" >>$idx
for FILE in $FILES
do
	if [ ! -f "$FILE" ]
	then
		continue;
	fi
	
	toc="cdoc/`basename $FILE .h`.html"
	echo -e "<html><head><title>`basename $FILE`</title></head>\n<body>" >$toc
	echo "<h4>Functions in `basename $FILE`</h4>" >>$toc

	echo "<a href=\"`basename $toc`\">`basename $FILE`</a><br>" >>$idx

	for cl in `grep -n "/\*\*" $FILE|cut -d: -f-1`
	do
		TMP=`mktemp`
		end1=`sed -n "$cl,\`cat $FILE|wc -l\` p" $FILE|grep -n -m 1 ";"|cut -d: -f-1`
		end=`expr \`expr $end1 - 1\` + $cl`
		sed -n "$cl,$end p" $FILE >$TMP
	
		title=`tail -n 1 $TMP|cut -d" " -f2|sed 's/\*//g'`
		of="cdoc/$title.html"
		desc=`head -n 1 $TMP|cut -d* -f3-`
		proto=`tail -n 1 $TMP`
		retval=`grep "@return" $TMP|cut -d" " -f2-|sed \
			's/BOOL/Returns 0 when the function was succesfull, else non-zero./'`
		if grep -q "@freeret" $TMP
		then
			retval="$retval The return value must be free'd."
		fi

		echo "<a href=\"`basename $of`\">$title</a><br>" >>$toc

		echo "<html><head><title>$title</title></head>" >$of
		echo "<body>" >>$of
		echo "<p><h4>Synopsis</h4>$title - $desc</p>" >>$of
		echo -e "<p><h4>Prototype</h4>\n#include &lt;`basename $FILE`&gt;<br>" >>$of
		echo "$proto</p>" >>$of
		echo "<p><h4>Parameters</h4>" >>$of
		for para in `grep "@param" $TMP|cut -d" " -f2-|sed 's/ /_/g'`
		do
			echo -n $para|sed -e 's/_/: /' -e 's/_/ /g' >>$of
			echo "<br>" >>$of
		done
		echo "</p>" >>$of
		echo -e "<p><h4>Return value</h4>\n$retval" >>$of
		echo "</body></html>" >>$of
	
		rm -f $TMP
	done
	echo "</body></html" >>$toc
done
echo "</body></html" >>$idx
